﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Concurrency.TestTools.UnitTesting;
using System.Threading.Tasks;
using Microsoft.Concurrency.TestTools.UnitTesting.Chess;
using Microsoft.Concurrency.TestTools.Extensions;

namespace AlpacaProject
{
    public class Atomicity_RoomPoint_Class
    {

        class Robot
        {
            public RoomPoint Location;
        }

        class RoomPoint
        {
            public long X;
            public long Y;
            public long Z;

            public RoomPoint(int x, int y, int z)
            {
                X = x;
                Y = y;
                Z = z;
            }

            public override string ToString()
            {
                return String.Concat('(', X, ',', Y, ',', Z, ')');
            }

        }

        [ChessTestMethod()]
        [ChessTestContext("Atomicity", EnableAtomicityChecking = true)]
        [ChessTestContext("Atomicity+PreemptsAll", EnableAtomicityChecking = true, PreemptAllAccesses = true)]
        [ChessTestContext("Atomicity+PreemptsAll+DataRace", EnableAtomicityChecking = true, PreemptAllAccesses = true, EnableRaceDetection = true)]
        public void TestAtomicity()
        {
            // Initialize our robot to some arbitrary location
            var r = new Robot() {
                Location = new RoomPoint(5, 6, 7)
            };

            RoomPoint pt = new RoomPoint(0, 0, 0);
            FauxParallel.Invoke(
                () => pt = r.Location
                , () => r.Location = new RoomPoint(1, 2, 3)
                );

            Console.WriteLine("pt={0}", pt);
        }

    }

    public class Atomicity_RoomPoint_Struct
    {

        class Robot
        {
            public RoomPoint Location;
        }

        struct RoomPoint
        {
            public long X;
            public long Y;
            public long Z;

            public RoomPoint(long x, long y, long z)
            {
                X = x;
                Y = y;
                Z = z;
            }

            public override string ToString()
            {
                return String.Concat('(', X, ',', Y, ',', Z, ')');
            }

        }

        [ChessTestMethod()]
        [ChessTestContext("")]
        [ChessTestContext("Atomicity", EnableAtomicityChecking = true)]
        [ChessTestContext("DataRace", EnableRaceDetection = true)]
        [ChessTestContext("Atomicity+PreemptsAll", EnableAtomicityChecking = true, PreemptAllAccesses = true)]
        [ChessTestContext("Atomicity+PreemptsAll+DataRace", EnableAtomicityChecking = true, PreemptAllAccesses = true, EnableRaceDetection = true)]
        public void TestAtomicity()
        {
            // Initialize our robot to some arbitrary location
            var r = new Robot() {
                Location = new RoomPoint(5, 6, 7)
            };

            RoomPoint pt = new RoomPoint(0, 0, 0);
            FauxParallel.Invoke(
                () => pt = r.Location
                , () => r.Location = new RoomPoint(1, 2, 3)
                );

            Console.WriteLine("pt={0}", pt);
        }

    }
}
