﻿using AntisocialRobots;
using Microsoft.Concurrency.TestTools.UnitTesting;
using System;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using Microsoft.Concurrency.TestTools.UnitTesting.Chess;

namespace AlpacaProject
{
    public static class RobotSimulationScenarioUtil
    {

        /// <summary>
        /// Creates a new <see cref="RobotSimulation"/> instance populated with robots
        /// at locations specified.
        /// </summary>
        /// <param name="size"></param>
        /// <param name="roomXs"></param>
        /// <param name="roomYs"></param>
        /// <param name="areMovable">Specifies whether the robots should be movable or not.</param>
        /// <returns></returns>
        public static RobotSimulation RobotSimulationFactory(
            int size, int[] roomXs, int[] roomYs
            , bool areMovable)
        {
            var room = new RobotSimulation(size);

            for (int i = 0; i < roomXs.Length; i++)
                room.CreateRobot(roomXs[i], roomYs[i], areMovable);

            return room;
        }

    }
}
