﻿using AntisocialRobots;
using Microsoft.Concurrency.TestTools.UnitTesting;
using System;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using Microsoft.Concurrency.TestTools.UnitTesting.Chess;

namespace AlpacaProject
{
    /// <summary>
    ///</summary>
    public class RobotSimulationScenario_ContendForSameCell
    {

        static int[] MyRoomX = new[] {
            0, 1,    3, 4,
            0, 1,    3, 4,
            0,          4,
            0, 1, 2, 3, 4,
            0, 1, 2, 3, 4,
        };

        static int[] MyRoomY = new[] {
            0, 0,    0, 0,
            1, 1,    1, 1,
            2,          2,
            3, 3, 3, 3, 3,
            4, 4, 4, 4, 4,
        };

        public static readonly RoomPoint R1_StartLocation = new RoomPoint(1, 2);
        public static readonly RoomPoint R2_StartLocation = new RoomPoint(3, 2);
        public static readonly RoomPoint ExpectedLocation = new RoomPoint(2, 1);

        public static RobotSimulation CreateSimulation(out Robot r1, out Robot r2)
        {
            var simulation = RobotSimulationScenarioUtil.RobotSimulationFactory(5, MyRoomX, MyRoomY, false);

            r1 = simulation.CreateRobot(R1_StartLocation);
            r2 = simulation.CreateRobot(R2_StartLocation);

            return simulation;
        }

        /// <summary>
        /// Verifies the DataRaceScenario map setup is correct.
        /// </summary>
        [UnitTestMethod]
        public void TestScenarioBehavior()
        {
            var roomA = RobotSimulationScenarioUtil.RobotSimulationFactory(5, MyRoomX, MyRoomY, false);
            var r1 = roomA.CreateRobot(R1_StartLocation, true);
            roomA.CreateRobot(R2_StartLocation, false);
            roomA.PerformFrameUpdate();
            Assert.AreEqual(ExpectedLocation, r1.Location, "Robot 1: Doesn't want to move to the location we expect for this test.");

            var roomB = RobotSimulationScenarioUtil.RobotSimulationFactory(5, MyRoomX, MyRoomY, false);
            roomB.CreateRobot(R1_StartLocation, false);
            var r2 = roomB.CreateRobot(R2_StartLocation, true);
            roomB.PerformFrameUpdate();
            Assert.AreEqual(ExpectedLocation, r2.Location, "Robot 2: Doesn't want to move to the location we expect for this test.");
        }

    }
}
