﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Concurrency.TestTools.UnitTesting;

namespace AlpacaProject.ReplicationPatterns
{
    public class GameTests
    {

        [DataRaceTestMethod()]
        public void SequentialGame()
        {
            var game = new SequentialGame(100);
            game.Run(1);
        }

        [DataRaceTestMethod()]
        public void NaiveParallelGame()
        {
            var game = new NaiveParallelGame(100);
            game.Run(1);
        }

        [DataRaceTestMethod()]
        public void ImmutableGame()
        {
            var game = new ImmutableGame(100);
            game.Run(1);
        }

        [DataRaceTestMethod()]
        public void DoubleBufferedGame()
        {
            var game = new DoubleBufferedGame(100);
            game.Run(1);
        }

    }
}
