﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AlpacaProject.ReplicationPatterns
{
    class SimpleImmutableList<T> : IImmutableSimpleList<T>
    {

        private T[] _items;

        public SimpleImmutableList()
        {
            _items = new T[0];
        }

        public int Count { get { return _items.Length; } }
        public T this[int index] { get { return _items[index]; } }

        public SimpleImmutableList<T> Add(T item)
        {
            T[] items = new T[_items.Length + 1];
            Array.Copy(_items, items, _items.Length);
            items[items.Length - 1] = item;

            return new SimpleImmutableList<T> { _items = items };
        }

        IImmutableSimpleList<T> IImmutableSimpleList<T>.Add(T item)
        {
            return Add(item);
        }

    }
}
